#include <iostream>
#include <vector>
#include <string>
#include <windows.h>

// structure to represent a quiz question
struct Question {
    std::string questionText;
    std::vector<std::string> options;
    int correctOption;
};

// function to display a question and receive answer
int askQuestion(const Question& question) {
    std::cout << question.questionText << "\n";

    for (size_t i = 0; i < question.options.size(); ++i) {
        std::cout << i + 1 << ". " << question.options[i] << "\n";
    }

    int userAnswer;
    std::cout << "Your answer (1-" << question.options.size() << "): ";
    std::cin >> userAnswer;

    return userAnswer;
}

int main() {
    // define quiz questions
    std::vector<Question> quizQuestions = {
        // {"question", {"ans1", "ans2", "ans3", "ans4"}, 1} copy/paste to add more questions (include a , after)
        {"which acid is produced by the stomach to aid in digestion?", {"acetic acid", "sulfuric acid", "nitric acid", "hydrochloric acid"}, 4},
        {"what is the muscular movement that helps mix and process food in the stomach?", {"segmentation", "swallowing", "churning", "peristalsis"}, 3},
        {"what lining prevents the stomach from digesting itself?", {"mucus layer", "serous membrane", "joking membrane", "keratin"}, 1},
        {"what's the term for when you'r stomach growls whilst everything else is silent?", {"gastroacousitc manifestation", "digestive symphony", "auditory gastronomy", "peristaltic serenade"}, 1},
        {"what is the medical term term for the sensation of butterflies in the stomach?", {"gastroflutteritis", "entomogastic sensation", "abdominal lepidopterism", "stomach papillon syndrome"}, 2},
        {"what diet was initiated by plato, where followers would eat exclusively thoughts and ideas", {"wisdom feast", "hunger for fear", "conceptual consuming", "Dinner"}, 4},
        {"which zelda character said the famous line 'i wonder what's for dinner'?", {"zelda", "link", "king harkinian", "gannon"}, 3},
        {"alright i'm sick of this shit let's ask some real questions", {"okay", "sure", "alright", "cool"}, 2},
        {"we hate Martin right? that fuckin mod wannabe. he should go back to somethingawful or wherever he came from", {"yes", "no", "i like him", "fuck you"}, 1},
        {"dirtylarry007. thoughts?", {"love him", "smells shit", "ANSWER3", "ANSWER4"}, 2},
        {"sorry that it's not text input i can't figure out how to do this. i have history homework due and don't have time for this shit", {"ANSWER1", "ANSWER2", "ANSWER3", "ANSWER4"}, 4},
        {"who is the coolest nintendo character", {"mario", "zelda", "pikachu", "samus"}, 2},
        {"if you didn't answer zelda i h8 you. he's the coolest he's so funny he's mr. ytp", {"i did", "did not. he's stuid", "ans3", "ans4"}, 1}
    };

    int score = 0;

    // go through each one
    for (const auto& question : quizQuestions) {
        // Ask the question and get the user's answer
        int userAnswer = askQuestion(question);

        // check if ans is right + update score
        if (userAnswer == question.correctOption) {
            std::cout << "Correct!\n";
            ++score;
        } else {
            std::cout << "Incorrect. The correct answer is: " << question.correctOption << ". " << question.options[question.correctOption - 1] << "\n";
        }

        std::cout << "\n";
    }

    // final score
    std::cout << "Quiz completed. Your score: " << score << "/" << quizQuestions.size() << "\n";

    std::cout << "Press Enter to continue...";
    std::cin.ignore();  // Clear the newline character from the buffer
    std::cin.get();     // Wait for Enter

    // launch part 2
    ShellExecute(NULL, "open", "POSE1_REBAIA_PART2.exe", NULL, NULL, SW_SHOWDEFAULT);

    return 0;
}
